﻿using System;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Streams;
using Windows.System.UserProfile;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// 메인 페이지
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainPage()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.setButton.Click += setButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 설정 버튼 클릭시 처리하기 - setButton_Click(sender, e)

        /// <summary>
        /// 설정 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void setButton_Click(object sender, RoutedEventArgs e)
        {
            FileOpenPicker picker = new FileOpenPicker
            {
                ViewMode               = PickerViewMode.Thumbnail,
                SuggestedStartLocation = PickerLocationId.PicturesLibrary,
                FileTypeFilter         = { ".jpg", ".jpeg", ".png", ".bmp" }
            };

            StorageFile file = await picker.PickSingleFileAsync();

            if(file != null)
            {
                try
                {
                    await LockScreen.SetImageFileAsync(file);

                    IRandomAccessStream stream = LockScreen.GetImageStream();

                    if(stream != null)
                    {
                        BitmapImage bitmapImage = new BitmapImage();

                        bitmapImage.SetSource(stream);

                        this.image.Source = bitmapImage;
                    }
                    else
                    {
                        this.image.Source = null;
                    }
                }
                catch(Exception)
                {
                    this.image.Source = null;
                }
            }
            else
            {
                this.image.Source = null;
            }
        }

        #endregion
    }
}